---
- name: Hosts get all hosts facts
  ansible.builtin.setup:
  when: 
    - ansible_facts != ''
    - hosts_add
  tags:
    - hosts
  
- name: Hosts add to /etc/hosts
  become: yes
  ansible.builtin.blockinfile:
    dest: /etc/hosts
    block: |
      {{ item.ansible_default_ipv4.address }} {{ item.ansible_hostname }}
    marker: "# {mark} host {{ item.ansible_hostname }}"
    state: present
  loop: "{{ hostvars.values() }}"
  when: hosts_add
  tags:
    - hosts
  
- name: Hosts get list of running containers
  command: docker ps --format json
  register: __containers
  when: docker_to_hosts
  tags:
    - hosts_docker
  
    
- name: Hosts Parse JSON output
  set_fact:
    __docker_containers: "{{ __containers.stdout.split('\n') | map('from_json') | list }}"
  when: docker_to_hosts
  tags:
    - hosts_docker
  
- name: Hosts get info wrom docker on host
  community.docker.docker_container_info:
    name: "{{ item.Names }}"
  register: __docker_facts
  loop: "{{ __docker_containers }}"
  when: docker_to_hosts
  tags:
    - hosts_docker
  
- name: Hosts add docker host to /etc/hosts
  become: yes
  ansible.builtin.blockinfile:
    dest: /etc/hosts
    block: |
      {{ item.container.NetworkSettings.Networks[item.container.HostConfig.NetworkMode].IPAddress }} {{ item.item.Names }}
    marker: "# {mark} docker host {{ item.item.Names }}"
    state: present
  loop: "{{ __docker_facts.results }}"
  when: docker_to_hosts and item.container.State.Running 
  tags:
    - hosts_docker
